## libosl 0.8.0

=== CMakeLists.txt ===
project (osl CXX)

# Tweak build mode
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "" FORCE)
endif()

if(NOT CMAKE_BUILD_TYPE MATCHES "^[Dd][Ee][Bb][Uu][Gg]")
  add_definitions(-DQT_NO_DEBUG_OUTPUT)
  set(CMAKE_BUILD_RELEASE TRUE)
else()
  set(CMAKE_BUILD_RELEASE FALSE)
endif()

# Installation directory
if(APPLE AND CMAKE_INSTALL_PREFIX MATCHES "/usr/local")
  set(CMAKE_INSTALL_PREFIX "/Applications")
endif()

message(STATUS "Building ${PROJECT_NAME} in ${CMAKE_BUILD_TYPE} mode")
cmake_minimum_required(VERSION 2.8.8)
set (CMAKE_VERBOSE_MAKEFILE on)

ENABLE_TESTING()

# Common build options
if(CMAKE_COMPILER_IS_GNUCXX OR MINGW OR APPLE)
  #if(CMAKE_BUILD_RELEASE)
  #        add_definitions(-Werror)
  #endif()
  add_compile_options(-std=c++11) #CMake 2.8.12 or newer
  #add_definitions(-std=c++11) #older than CMake 2.8.11
  set (CMAKE_CXX_FLAGS_DEBUG   "-g -O0 -DDEBUG")
  set (CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG")
  add_definitions(-Wall -D_REENTRANT -DOSL_SMP -DOSL_DFPN_SMP_SEARCH -DMORE_CHECKMATE_IF_CAPTURE_MAJOR)
  add_definitions(-DBOOST_FILESYSTEM_VERSION=3) 
endif()

# Compiler specific build options
if(MINGW)
  add_compile_options(-march=pentium4 -mthreads -mwin32 -msse2 -static-libgcc -static-libstdc++ -mstackrealign -fno-strict-aliasing)
  add_definitions(-D_MT -DWIN32_LEAN_AND_MEAN -D_WIN32_WINNT=0x0500)

  set (BOOST_ROOT "$ENV{HOME}/local/src/boost_1_54_0")
  set (Boost_NO_SYSTEM_PATHS ON)
  find_library(Winsock2_LIBRARY ws2_32)
elseif (APPLE)
  add_compile_options(-march=core2)
  add_definitions(-Wall -D_REENTRANT)  # -fno-common for shared library
  set (CMAKE_OSX_ARCHITECTURES x86_64)
  set (CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.9.sdk")
  set (CMAKE_OSX_DEPLOYMENT_TARGET 10.6)

  set (BOOST_ROOT "/usr/local/Cellar/boost/1.54.0")
elseif (UNIX)
  add_compile_options(-march=native)
endif()

if (APPLE)
  add_definitions(-DOSL_HOME="/Applications/gpsfish.app/Contents/Resources")
else()
  add_definitions(-DOSL_HOME="${CMAKE_CURRENT_SOURCE_DIR}")
endif()

include_directories ("${PROJECT_SOURCE_DIR}/core")
include_directories ("${PROJECT_SOURCE_DIR}/std")
include_directories ("${PROJECT_SOURCE_DIR}/full")

## Pthreads
#find_package (Threads)
#if (Threads_FOUND)
#  message (STATUS "Threads: ${CMAKE_THREAD_LIBS_INIT}")
#else()
#  message (FATAL_ERROR "Threads not found")
#endif()

## Boost thing
#set (BOOST_ROOT "$ENV{HOME}/local/boost_1_36_0_binaries/")
set (Boost_USE_STATIC_LIBS ON)
set (Boost_USE_MULTITHREADED ON)
if (MINGW)
  find_package (Boost 1.54.0)
else()
  find_package (Boost 1.54.0)
endif()
if (Boost_FOUND)
  include_directories (${Boost_INCLUDE_DIRS})
  message (STATUS ${Boost_INCLUDE_DIRS})
else()
  message (FATAL_ERROR "Boost installation not found")
endif()

## Program SampleCounter
file(GLOB_RECURSE OSL_HEADERS  core/osl/*.h core/osl/*.tcc std/osl/*.h std/osl/*.tcc full/osl/*.h full/osl/*.tcc)
file(GLOB_RECURSE OSL_SRCS     core/osl/*.cc std/osl/*.cc full/osl/*.cc)
file(GLOB_RECURSE EXCLUDE_SRCS full/osl/ntesuki/*.cc)
list(REMOVE_ITEM OSL_SRCS ${EXCLUDE_SRCS})

#message (STATUS "Headers: ${OSL_HEADERS}")
#message (STATUS "Sources: ${OSL_SRCS}")
#set (SampleAleriUDF_ALL_SRCS ${SampleAleriUDF_HEADERS} ${SampleAleriUDF_SRCS})
add_library (osl-static STATIC ${OSL_SRCS})
SET_TARGET_PROPERTIES(osl-static PROPERTIES OUTPUT_NAME "osl")
SET_TARGET_PROPERTIES(osl-static PROPERTIES PREFIX "lib")
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  add_library (osl SHARED ${OSL_SRCS})
  target_link_libraries (osl ${CMAKE_THREAD_LIBS_INIT})
endif()

=== Makefile ===
-include makefile.local
include makefile.conf
all: 
	$(MAKE) -C core/osl
	$(MAKE) -C std/osl
	$(MAKE) -C full/osl
debug:
	$(MAKE) DEBUG=t all make-test
clean:
	$(MAKE) -C core/osl clean
	$(MAKE) -C std/osl clean
	$(MAKE) -C full/osl clean
	$(MAKE) -C core/test clean
	$(MAKE) -C std/test clean
	$(MAKE) -C full/test clean
make-test:
	$(MAKE) -C core/test
	$(MAKE) -C std/test 
	$(MAKE) -C full/test
run-test: make-test
	(cd core/test; ./testAll) && (cd std/test; ./testAll) && (cd full/test; ./testAll)



# ETAGS ?= etags
# 
# all : third-party
# 	$(MAKE) -C lib
# 	$(MAKE) -C test
# 	$(MAKE) -C sample
# third-party: lib/third_party/$(TCMALLOC)/Makefile lib/third_party/$(GTEST)/Makefile lib/third_party/$(PROTOBUF)/Makefile
# ifeq ($(USE_TCMALLOC),1)
# 	$(MAKE) -C lib/third_party/$(TCMALLOC)
# endif
# 	$(MAKE) -C lib/third_party/$(GTEST)
# 	$(MAKE) -C lib/third_party/$(PROTOBUF)
# 
# prof : 
# 	$(MAKE) PROFILE=true -C lib
# 
# clean:
# 	$(MAKE) -C lib clean
# 	$(MAKE) -C release clean
# 	$(MAKE) -C profile clean
# 	$(MAKE) -C test clean
# 	$(MAKE) -C sample clean
# 	$(MAKE) -C doc clean
# cleandeps:
# 	rm -rf lib/.deps lib/.objs lib/lib*.a
# 	rm -rf release/.deps release/.objs release/lib*.a
# 	rm -rf profile/.deps profile/.objs profile/lib*.a
# 	rm -rf sample/.deps sample/.objs
# 	rm -rf test/.deps test/.objs
# 
# tags:
# 	-rm TAGS
# 	for d in include/osl lib; do \
#           find $$d \( -name "*.h" -o -name "*.cc" -o -name "*.tcc" \) -exec $(ETAGS) --append --language=c++ {} \;; \
# 	done
# html:
# 	cd doc; $(MAKE)
# 
# lib/third_party/$(TCMALLOC)/Makefile: lib/third_party/$(TCMALLOC)/configure
# 	cd lib/third_party/$(TCMALLOC); env CXX=$(CXX) ./configure --disable-cpu-profiler --disable-heap-profiler --disable-heap-checker --disable-debugalloc --enable-minimal --enable-shared=no
# lib/third_party/$(GTEST)/Makefile: lib/third_party/$(GTEST)/configure
# 	cd lib/third_party/$(GTEST); env CXX=$(CXX) ./configure 
# lib/third_party/$(PROTOBUF)/Makefile: lib/third_party/$(PROTOBUF)/configure
# 	cd lib/third_party/$(PROTOBUF); env CXX=$(CXX) ./configure 
# 
# add-utf-8-bom:
# 	find . \( -name "*.h" -o -name "*.tcc" -o -name "*.cc" \) -exec nkf -w8 --overwrite {} \;
# 
# remove-utf-8-bom:
# 	find . \( -name "*.h" -o -name "*.tcc" -o -name "*.cc" \) -exec nkf -w --overwrite {} \;

=== doc/Makefile ===
DOXYGEN ?= doxygen
all:
	doxygen
	find . -name '*.html' -exec perl -pi -e 's/td nowrap/td/g' {} \;

clean:
	rm -f  doxygen.err
	rm -rf html
	rm -rf latex

.PHONY: all clean

=== sample/Makefile ===
OSL_HOME = ..
-include makefile.local
-include $(OSL_HOME)/makefile.local
include $(OSL_HOME)/makefile.conf

LDFLAGS += -L../full/osl -L../std/osl -L../core/osl
LOADLIBES += -losl_full -losl_std -losl_core $(BOOST_LIBS) -lboost_regex -lboost_program_options $(LDLIBS)
INCLUDES += -I$(OSL_HOME)/full -I$(OSL_HOME)/std -I$(OSL_HOME)/core

PERFORMANCE_SRCS = isCheckPerf.cc \
  pin_perf.cc \
  progress_perf.cc rating-perf.cc see-perf.cc simpleMovePerf.cc
# commented out because their compilation take very long time: checkMovePerf.cc  fixedDepthSearchPerf.cc
EVAL_SRCS = show-state.cc show-progresseval.cc show-eval.cc  \
  openmidending-stat.cc
PPAIR_SRCS = pairdiff.cc pairedit.cc pairstat.cc 
DEBUG_SRCS = printPdp.cc printPosition.cc printMove.cc printPiece.cc \
	printPtypeO.cc 
OPENING_SRCS = convert.cc showOpening.cc opening-validator.cc openingStatistics.cc \
	compare-book.cc show-moves.cc
RATING_SRCS = ratingstat.cc probability.cc topn.cc
CHECKMATE_SRCS = dfpnstat.cc fixed-checkmate.cc  make-problems.cc
RECORD_SRCS = check-kisen.cc show-ipx.cc all-states.cc bad-moves.cc \
              show-ki2.cc show-ipx-result.cc csa-to-kisen.cc kisen-to-csa.cc \
	      count-win-loss.cc win-rate-openingbook-weight-level.cc \
              all-states2.cc find-states.cc check-ki2.cc showRecord.cc \
	      kakinoki-to-csa.cc csa-to-kifu.cc kifu-to-myshogi.cc showRecord.cc \
	      last-position.cc unique-csa.cc first-search-eval.cc \
              csajapanize.cc
MISC_SRCS = showCores.cc showMemory.cc convert.cc
LEARN_SRCS = show-sibling.cc learn-piece.cc

BOARD_SRCS = random_play.cc search1_play.cc legal_moves.cc \
	show_repetition.cc show-effect.cc \
	progress/show-state.cc progress/progress.cc\
	$(patsubst %.cc,eval/%.cc,$(EVAL_SRCS)) \
	$(patsubst %.cc,eval/ppair/%.cc,$(PPAIR_SRCS)) \
	$(patsubst %.cc,record/%.cc,$(RECORD_SRCS)) \
	$(patsubst %.cc,misc/%.cc,$(MISC_SRCS))
SEARCH_SRCS = 	sort.cc pass.cc  \
	find-losing-moves.cc find-uplevel-king.cc find-almost-entering.cc \
	quiescence/quiescencestat.cc quiescence/range-vs-nodes.cc \
	quiescence/quiescence2stat.cc \
	$(patsubst %.cc,checkmate/%.cc,$(CHECKMATE_SRCS)) \
	$(patsubst %.cc,debug/%.cc,$(DEBUG_SRCS)) \
	$(patsubst %.cc,opening/%.cc,$(OPENING_SRCS)) \
	$(patsubst %.cc,rating/%.cc,$(RATING_SRCS)) \
	annotate/annotate.cc \
	$(patsubst %.cc,performance/%.cc,$(PERFORMANCE_SRCS)) \
	$(patsubst %.cc,learn/%.cc,$(LEARN_SRCS)) \
	record/checkmate-kisen.cc

BOARD_PROGRAMS = $(BOARD_SRCS:.cc=) 
SEARCH_PROGRAMS = $(SEARCH_SRCS:.cc=) 
PROGRAMS = $(BOARD_PROGRAMS) $(SEARCH_PROGRAMS)
CC = $(CXX)

all: $(BOARD_PROGRAMS) $(SEARCH_PROGRAMS)
$(PROGRAMS): $(FILE_OSL_ALL)

# CC, LDFLAGS, LOADLIBES を定義しておくと
# %.o から % を勝手に作ってくれるので
# 特別なもの以外は書く必要がない
opening/convert: opening/convert.o opening/openingBookConverter.o
opening/openingBookConverter.o: opening/openingBookConverter.cc opening/openingBookConverter.h

checkmate/dfpnstatone-static: checkmate/dfpnstatone.cc checkmate/dfpnstat.cc
	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC)  $(LOADLIBES)


clean: 
	rm -f core *.o */*.o $(PROGRAMS) nohup.out *~
distclean: clean 
	rm -f *~

-include $(patsubst %.cc,.deps/%.cc.d,$(BOARD_SRCS))
-include $(patsubst %.cc,.deps/%.cc.d,$(SEARCH_SRCS))

# hash-dump.cc
# fixed-checkmate2.cc

=== core/osl/Makefile ===
OSL_HOME = ../..
-include makefile.local
-include $(OSL_HOME)/makefile.local
include $(OSL_HOME)/makefile.conf

OSL_HOME_FLAGS = -DOSL_HOME=\"$(shell dirname $(shell dirname `pwd`))\"
CXXFLAGS += $(OSL_HOME_FLAGS)

EVAL_SRC = openMidEndingEval.cc \
 king8.cc       minorPiece.cc         ptypeEval.cc      eval_pieceStand.cc  weights.cc \
 kingTable.cc   mobility.cc           piecePair.cc      eval_pin.cc \
 majorPiece.cc  piecePairKing.cc  eval_progress.cc see.cc
MOBILITY_SRC = mobilityTable.cc
CHECKMATE_SRC = fixedDepthSearcher.cc immediateCheckmate.cc immediateCheckmateTable.cc \
 proofDisproof.cc
MOVE_GENERATOR_SRC = capture_.cc escape_.cc allMoves.cc drop.cc pieceOnBoard.cc \
  addEffectWithEffect.cc promote_.cc
BOOK_SRC = bookInMemory.cc  compactBoard.cc  openingBook.cc
BITS_SRC = \
 align16New.cc  boardTable.cc        mask.cc             pieceStand.cc \
 binaryIO.cc    centering5x3.cc      numSimpleEffect.cc  pieceTable.cc \
 bitXmask.cc    effectedNumTable.cc           ptypeTable.cc \
 boardMask.cc   king8Info.cc         pieceMask.cc        squareCompressor.cc \
 tables.cc
SRCS = 	$(patsubst %.cc,bits/%.cc,$(BITS_SRC)) \
 $(patsubst %.cc,book/%.cc,$(BOOK_SRC)) \
 $(patsubst %.cc,eval/%.cc,$(EVAL_SRC)) \
 $(patsubst %.cc,mobility/%.cc,$(MOBILITY_SRC)) \
 $(patsubst %.cc,checkmate/%.cc,$(CHECKMATE_SRC)) \
 $(patsubst %.cc,move_generator/%.cc,$(MOVE_GENERATOR_SRC)) \
 move_classifier/kingOpenMove.cc \
 additionalEffect.cc  enterKing.cc        numEffectState.cc  progress.cc \
 basic_type.cc        hashKey.cc          oslConfig.cc       random.cc \
 csa.cc               container.cc       simpleState.cc \
 usi.cc

OBJS = $(patsubst %.cc,%.o,$(SRCS))
DEPS = $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

all: libosl_core.a

light-clean:
	-rm -rf .deps
	-rm -f *.a
clean: light-clean
	-rm $(OBJS)

-include $(DEPS)
libosl_core.a : $(OBJS)

=== core/test/Makefile ===
OSL_HOME = ../..
-include makefile.local
-include $(OSL_HOME)/makefile.local
-include $(OSL_HOME)/makefile.conf

LDFLAGS += -L../osl 
LOADLIBES += -losl_core $(BOOST_LIBS) -lboost_unit_test_framework $(LDLIBS)

PROGRAMS = testAll

MOVE_GENERATOR_SRCS = escapeMoves.t.cc capture_.t.cc addEffectWithEffect.t.cc \
 allMoves.t.cc promote_.t.cc
BOOK_SRC = bookInMemory.t.cc  compactBoard.t.cc  openingBook.t.cc
MOBILITY_SRC = bishopMobility.t.cc  lanceMobility.t.cc  rookMobility.t.cc \
 countMobility.t.cc   mobilityTable.t.cc
SRCS = $(patsubst %.cc,move_generator/%.cc,$(MOVE_GENERATOR_SRCS)) \
 $(patsubst %.cc,book/%.cc,$(BOOK_SRC)) \
 $(patsubst %.cc,mobility/%.cc,$(MOBILITY_SRC)) \
 move_classifier/check_.t.cc  move_classifier/kingOpenMove.t.cc  move_classifier/safeMove.t.cc \
 eval/openMidEndingEval.t.cc  eval/piecePair.t.cc  eval/see.t.cc \
 checkmate/immediateCheckmate.t.cc \
 board.t.cc      enterKing.t.cc  numEffectState.t.cc  player.t.cc    quadInt.t.cc \
 carray.t.cc     hashKey.t.cc    piece.t.cc           progress.t.cc  usi.t.cc \
 csa.t.cc        king8Info.t.cc  pieceMask.t.cc       psn.t.cc \
 direction.t.cc  move.t.cc       pieceStand.t.cc      ptype.t.cc \
 fixedCapacityVector.t.cc ptypeOSquareVector.t.cc

TEST_OBJS = $(patsubst %.cc,%.o,$(SRCS))
OBJS = testAll.o $(TEST_OBJS)

all : 
	$(MAKE) update-lib
	$(MAKE) test-target
test-target:
	$(MAKE) $(PROGRAMS)
update-lib:
	cd ../osl; $(MAKE)

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

testAll: $(OBJS) $(FILE_OSL_CORE)
	mkdir -p `dirname $@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $@ $^ $(LOADLIBES) 

%.t: %.t.o testOne.o $(FILE_OSL_CORE)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LOADLIBES) 

light-clean:
	-rm -rf .deps 
clean: light-clean
	-rm -f core *.o $(OBJS) $(PROGRAMS) nohup.out checkmate.log

=== full/osl/Makefile ===
OSL_HOME = ../..
-include makefile.local
-include $(OSL_HOME)/makefile.local
include $(OSL_HOME)/makefile.conf

OSL_HOME_FLAGS = -DOSL_HOME=\"$(shell dirname $(shell dirname `pwd`))\"
CXXFLAGS += $(OSL_HOME_FLAGS)
INCLUDES += -I.. -I../../std -I../../core

ANNOTATE_SRC = analysesResult.cc  analyzer.cc  anno-facade.cc
EU_SRC = effectUtil.cc  pin.cc  virtualPin.cc
GP_SRC = \
 alphaBetaPlayer.cc cuiClient.cc     recordTracer.cc       usiResponse.cc \
 bookPlayer.cc    gameManager.cc    searchPlayer.cc       usiState.cc \
 computerPlayer.cc  gameState.cc     speculativeAllMoves.cc   weightTracer.cc \
 csaClient.cc    gnuShogiClient.cc   speculativeModel.cc     winCountTracer.cc \
 csaLogger.cc    historyToTable.cc   speculativeSearchPlayer.cc \
 csaTime.cc     openingBookTracer.cc timeKeeper.cc
SEARCH_SRC = \
 alphaBeta2.cc                   hashRejections.cc       searchMonitor.cc \
 alphaBeta2Parallel.cc           historyTable.cc         searchRecorder.cc \
 alphaBeta3.cc                   killerMoveTable.cc      searchState2.cc \
 alphaBeta4.cc                   moveGenerator.cc        searchTimer.cc \
 analyzer/categoryMoveVector.cc  moveScore.cc            simpleHashRecord.cc \
 analyzer/dotWriter.cc           moveStackRejections.cc  simpleHashTable.cc \
 analyzer/logWriter.cc           moveWithComment.cc      sortCaptureMoves.cc \
 analyzer/recordSet_.cc          quiescenceGenerator.cc  threatmateState.cc \
 bigramKillerMove.cc             quiescenceLog.cc        timeControl.cc \
 breakThreatmate.cc              quiescenceRecord.cc     usiReporter.cc \
 dualThreatmateState.cc          quiescenceSearch2.cc \
 limitToCheckCount.cc  usiProxy.cc interimReport.cc
EVAL_SRC = \
 endgame/attackDefense.cc endgame/attackKing.cc endgame/defenseKing.cc \
 endgame/kingPieceTable.cc pieceEval.cc ppair/piecePairEvalBase.cc \
 ppair/piecePairPieceTable.cc ppair/piecePairRawTable.cc  progressEval.cc \
 eval_mobilityTable.cc
MG_SRC = \
 addEffect8.cc  attackToPinned.cc additionalLance.cc addEffect8Table.cc

THREATMATE_SRC = kfendPredictor.cc mlPredictor.cc richPredictor.cc treePredictor.cc
SRCS = 	\
 $(patsubst %.cc,annotate/%.cc,$(ANNOTATE_SRC)) \
 $(patsubst %.cc,effect_util/%.cc,$(EU_SRC)) \
 $(patsubst %.cc,eval/%.cc,$(EVAL_SRC)) \
 $(patsubst %.cc,move_generator/%.cc,$(MG_SRC)) \
 $(patsubst %.cc,game_playing/%.cc,$(GP_SRC)) \
 $(patsubst %.cc,record/%.cc,$(RECORD_SRC)) \
 $(patsubst %.cc,search/%.cc,$(SEARCH_SRC)) \
 $(patsubst %.cc,threatmate/%.cc,$(THREATMATE_SRC)) \
 enter_king/simplePredictor.cc enter_king/enterKingUtil.cc \
 c/facade.cc container/pieceValues.cc state/historyState.cc \
 misc/characterEncodingConvertWin32.cc  misc/perfmon.cc \
 misc/log/htmlPerformanceLog.cc  misc/log/textPerformanceLog.cc \
 hash/hashRandom.cc

OBJS = $(patsubst %.cc,%.o,$(SRCS))
DEPS = $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

all: libosl_full.a

light-clean:
	-rm -rf .deps
	-rm -f *.a
clean: light-clean
	-rm $(OBJS)

-include $(DEPS)
libosl_full.a : $(OBJS)

=== full/test/Makefile ===
OSL_HOME = ../..
-include makefile.local
-include $(OSL_HOME)/makefile.local
-include $(OSL_HOME)/makefile.conf

LDFLAGS += -L../osl -L../../std/osl -L../../core/osl
LOADLIBES += -losl_full -losl_std -losl_core $(BOOST_LIBS) -lboost_unit_test_framework $(LDLIBS)
INCLUDES += -I.. -I../../std -I../../core

PROGRAMS = testAll

EVAL_SRC = \
 endgame/attackDefense.t.cc endgame/attackKing.t.cc endgame/defenseKing.t.cc \
 endgame/kingPieceTable.t.cc minorPieceBonus.t.cc pieceEval.t.cc \
 ppair/piecePairIndex.t.cc ppair/piecePairPieceEval.t.cc \
 ppair/piecePairRawEval.t.cc progressEval.t.cc
SEARCH_SRC = \
 alphaBeta2.t.cc		  lRUMoves.t.cc		    quiescenceSearch.t.cc \
 bigramKillerMove.t.cc	  moveGenerator.t.cc	    sacrificeCheck.t.cc \
 breakThreatmate.t.cc	  moveStackRejections.t.cc  searchRecorder.t.cc \
 dominanceCheck.t.cc	  problems.cc		    shouldPromoteCut.t.cc \
 dualThreatmateState.t.cc  	    simpleHashRecord.t.cc \
 fixedEval.t.cc		  quiescenceGenerator.t.cc  simpleHashTable.t.cc \
 hashRejections.t.cc	  quiescenceRecord.t.cc     threatmateState.t.cc
EU_SRC = additionalEffect.t.cc  neighboring8Direct.t.cc  sendOffSquare.t.cc \
 virtualPin.t.cc effectUtil.t.cc pin.t.cc shadowEffect.t.cc
GP_SRC = alphaBetaOpenMidEndingEvalPlayer.t.cc gameState.t.cc searchPlayer.t.cc \
 alphaBetaPlayer.t.cc gnuShogiClient.t.cc weightTracer.t.cc \
 bookPlayer.t.cc historyToTable.t.cc csaClient.t.cc recordTracer.t.cc
HASH_SRC =  hashRandom.t.cc
MP_SRC = addEffect8.t.cc  attackToPinned.t.cc  safeDropMajorPiece.t.cc
MO_SRC = captureEstimation.t.cc  captureSort.t.cc  cheapPtype.t.cc  promotion.t.cc
TP_SRC = kfendPredictor.t.cc  mlPredictor.t.cc  richPredictor.t.cc  treePredictor.t.cc

SRCS = $(patsubst %.cc,eval/%.cc,$(EVAL_SRC)) \
 $(patsubst %.cc,effect_util/%.cc,$(EU_SRC)) \
 $(patsubst %.cc,game_playing/%.cc,$(GP_SRC)) \
 $(patsubst %.cc,hash/%.cc,$(HASH_SRC)) \
 $(patsubst %.cc,move_generator/%.cc,$(MP_SRC)) \
 $(patsubst %.cc,move_order/%.cc,$(MO_SRC)) \
 $(patsubst %.cc,search/%.cc,$(SEARCH_SRC)) \
 $(patsubst %.cc,threatmate/%.cc,$(TP_SRC)) \
 enter_king/simplePredictor.t.cc  stat/twoDimensionalStatistics.t.cc \
 repetitionCounter.t.cc misc/math.t.cc

TEST_OBJS = $(patsubst %.cc,%.o,$(SRCS))
OBJS = testAll.o $(TEST_OBJS)

all : 
	$(MAKE) update-lib
	$(MAKE) test-target
test-target:
	$(MAKE) $(PROGRAMS)
update-lib:
	cd ../../core/osl; $(MAKE)
	cd ../../std/osl; $(MAKE)
	cd ../osl; $(MAKE)

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

testAll: $(OBJS) $(FILE_OSL_STD) $(FILE_OSL_CORE)
	mkdir -p `dirname $@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $@ $^ $(LOADLIBES) 

%.t: %.t.o testOne.o $(FILE_OSL_STD) $(FILE_OSL_CORE)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LOADLIBES) 

light-clean:
	-rm -rf .deps 
clean: light-clean
	-rm -f core *.o $(OBJS) $(PROGRAMS)

=== std/osl/Makefile ===
OSL_HOME = ../..
-include makefile.local
-include $(OSL_HOME)/makefile.local
include $(OSL_HOME)/makefile.conf

OSL_HOME_FLAGS = -DOSL_HOME=\"$(shell dirname $(shell dirname `pwd`))\"
CXXFLAGS += $(OSL_HOME_FLAGS)
INCLUDES += -I.. -I../../core

HASH_SRC = \
 hashKeyStack.cc hashRandomPair.cc
MISC_SRC = \
 base64.cc  eucToLang.cc  filePath.cc  iconvConvert.cc  sjis2euc.cc 
CHECKMATE_SRC = \
 dfpn.cc          dualDfpn.cc           pieceCost.cc         proofTreeDepthDfpn.cc \
 dfpnParallel.cc   proofNumberTable.cc checkmateIfCapture.cc fixedDepthSolverExt.cc
RECORD_SRC = \
 checkDuplicate.cc  kanjiMove.cc   kisen.cc            myshogi.cc \
 csaRecord.cc       kanjiPrint.cc        record.cc \
 kakinoki.cc        ki2.cc          usiRecord.cc
MP_SRC = feature_.cc  featureSet_.cc  moveInfo.cc  stateInfo.cc
RATING_SRC = \
 bradleyTerry.cc          feature/pattern.cc     group/king8Group.cc \
 feature.cc               feature/square.cc      group/patternGroup.cc \
 feature/bigramAttack.cc  featureSet.cc          group/squareGroup.cc \
 feature/capture.cc       group.cc               ratedMove.cc \
 feature/checkmate.cc     group/bigramGroup.cc   ratedMoveVector.cc \
 feature/countEffect2.cc  group/captureGroup.cc  ratingEnv.cc \
 feature/king8_.cc         group/escape.cc
PROGRESS_SRC = \
 effect5x3.cc  effect5x3Table.cc  effect5x3d.cc  ptypeProgress.cc
SRCS = 	$(patsubst %.cc,misc/%.cc,$(MISC_SRC)) \
 $(patsubst %.cc,hash/%.cc,$(HASH_SRC)) \
 $(patsubst %.cc,checkmate/%.cc,$(CHECKMATE_SRC)) \
 $(patsubst %.cc,record/%.cc,$(RECORD_SRC)) \
 $(patsubst %.cc,move_probability/%.cc,$(MP_SRC)) \
 $(patsubst %.cc,rating/%.cc,$(RATING_SRC)) \
 $(patsubst %.cc,progress/%.cc,$(PROGRESS_SRC)) \
 moveLogProb.cc  pathEncoding.cc  repetitionCounter.cc \
 book/miniBoard.cc  book/miniBoardChar50.cc effect_util/neighboring8Direct.cc \
 effect_util/shadowEffect.cc effect_util/sendOffSquare.cc \
 container/moveStack.cc container/square8.cc container/moveLogProbVector.cc \
 stat/histogram.cc stat/ratio.cc stat/twoDimensionalStatistics.cc \
 centering3x3.cc sennichite.cc

OBJS = $(patsubst %.cc,%.o,$(SRCS))
DEPS = $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

all: libosl_std.a

light-clean:
	-rm -rf .deps
	-rm -f *.a
clean: light-clean
	-rm $(OBJS)

-include $(DEPS)
libosl_std.a : $(OBJS) ../../core/osl/libosl_core.a

=== std/test/Makefile ===
OSL_HOME = ../..
-include makefile.local
-include $(OSL_HOME)/makefile.local
-include $(OSL_HOME)/makefile.conf

LDFLAGS += -L../osl -L../../core/osl
LOADLIBES += -losl_std -losl_core $(BOOST_LIBS) -lboost_unit_test_framework $(LDLIBS)
INCLUDES += -I.. -I../../core

PROGRAMS = testAll

CHECKMATE_SRC = \
 checkmateIfCapture.t.cc  fixedDepthSearcher.t.cc  proofDisproof.t.cc \
 dfpn.t.cc                oracleAdjust.t.cc        proofNumberTable.t.cc \
 dualDfpn.t.cc            oracleProver.t.cc        proofPieces.t.cc \
 pawnCheckmateMoves.t.cc pawnDropCheckmate.t.cc
MP_SRC = feature.t.cc  featureSet.t.cc  moveInfo.t.cc  stateInfo.t.cc
RATING_SRC = feature/patternLong.t.cc  ratedMoveVector.t.cc \
 feature/threatmate.t.cc   standardFeatureSet.t.cc
RECORD_SRC = kanjiMove.t.cc  kanjiPrint.t.cc  ki2.t.cc  kisen.t.cc  record.t.cc \
 csaRecord.t.cc
SRCS = $(patsubst %.cc,checkmate/%.cc,$(CHECKMATE_SRC)) \
 $(patsubst %.cc,move_probability/%.cc,$(MP_SRC)) \
 $(patsubst %.cc,rating/%.cc,$(RATING_SRC)) \
 $(patsubst %.cc,record/%.cc,$(RECORD_SRC)) \
 centering5x3.t.cc centering3x3.t.cc pathEncoding.t.cc \
 book/miniBoard.t.cc        misc/base64.t.cc         progress/effect5x3d.t.cc \
 book/miniBoardChar50.t.cc  progress/effect5x3.t.cc  progress/ptypeProgress.t.cc \
 moveStack.t.cc moveLogProbVector.t.cc

TEST_OBJS = $(patsubst %.cc,%.o,$(SRCS))
OBJS = testAll.o $(TEST_OBJS)

all : 
	$(MAKE) update-lib
	$(MAKE) test-target
test-target:
	$(MAKE) $(PROGRAMS)
update-lib:
	cd ../../core/osl; $(MAKE)
	cd ../../std/osl; $(MAKE)
	cd ../osl; $(MAKE)

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

testAll: $(OBJS) $(FILE_OSL_STD) $(FILE_OSL_CORE)
	mkdir -p `dirname $@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $@ $^ $(LOADLIBES) 

%.t: %.t.o testOne.o $(FILE_OSL_STD) $(FILE_OSL_CORE)
	$(CXX) $(LDFLAGS) -o $@ $^ $(LOADLIBES) 

light-clean:
	-rm -rf .deps 
clean: light-clean
	-rm -f core *.o $(OBJS) $(PROGRAMS)

=== debian/changelog ===
libosl (0.8.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113179)

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Oct 2025 17:08:08 +0200

libosl (0.8.0-4) unstable; urgency=medium

  * Add graphviz to build-depends for proper doxygen generation.
  * Re-export all patches with a single git-format-patch.
  * Fix build with gcc-11 (Closes: #984201)

 -- Yann Dirson <dirson@debian.org>  Wed, 17 Nov 2021 21:48:42 +0100

libosl (0.8.0-3) unstable; urgency=low

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use versioned copyright format URI.
  * Use secure URI in Homepage field.

 -- Yann Dirson <dirson@debian.org>  Thu, 20 Aug 2020 01:18:30 +0200

libosl (0.8.0-2) unstable; urgency=medium

  * New maintainer, raise package from the grave (Closes: #964732).
  * Add 0001-Import-svn-r4566.patch to sync with upstream svn.
  * Fix build with boost 1.67+ (Closes: #915761).
  * Set DH_VERBOSE=1.
  * Switch to debhelper compat v12,
    * remove non-matching install patterns
    * update doc-base to point to doc in doc/libosl-dev/
    * remove now-unnecessary dh '--parallel' option
  * Update Vcs-* for new salsa repo.
  * Explicitly link with relevant boost libraries.
  * Bump Standards-Version to 4.5.0.
  * Fix 'unkown' typo (lintian).

 -- Yann Dirson <dirson@debian.org>  Sat, 11 Jul 2020 00:26:45 +0200

libosl (0.8.0-1.4) unstable; urgency=medium

  * Non-maintainer upload.
  * makefile.conf: Append to CXXFLAGS instead of overwriting them.
  * detect-sse.patch: New, disable SSE unless the compiler advertised it.
  * Don't set DEB_CXXFLAGS_MAINT_APPEND any longer.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 30 Apr 2017 00:21:38 +0200

libosl (0.8.0-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Ship again makefile.conf, fixing FTBFS in gpsshogi.  (Closes: #861033)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Apr 2017 00:29:06 +0200

libosl (0.8.0-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Use DEB_CXXFLAGS_MAINT_APPEND to add -DOSL_NO_SSE on i386.
    (Closes: #852016)
  * Stop messing around with makefile.conf and makefile.local, they are not
    used by the CMake buildsystem.
  * Drop superfluous B-D: quilt.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 22 Apr 2017 19:10:51 +0200

libosl (0.8.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Import again previously unincorporated NMUs 0.6.0-3.{3,4}.
  * Complete (again) the library package rename after GCC5 ABI break.
    Closes: #797613 (again)
  * Use HTTPS in the Vcs-* fields.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 31 Mar 2017 02:28:56 +0200

libosl (0.8.0-1) unstable; urgency=medium

  * New upstream release (OSL r4566).
  * Dynamically generate documents for libosl-doc.

 -- Daigo Moriwaki <daigo@debian.org>  Sun, 01 Jan 2017 23:13:21 +0900

libosl (0.7.0-3) unstable; urgency=medium

  * Use jquery.js provided by libjs-jquery in doc/html/*.html.

 -- Daigo Moriwaki <daigo@debian.org>  Sun, 01 Jan 2017 21:30:40 +0900

libosl (0.7.0-2) unstable; urgency=medium

  * Add a patch to customize OSL_HOME
    - 0004-Customize-OSL_HOME.patch

 -- Daigo Moriwaki <daigo@debian.org>  Mon, 05 Dec 2016 22:06:36 +0900

libosl (0.7.0-1) unstable; urgency=medium

  * New upstream release (OSL r4564).
  * Switch to dh build with cmake from cdbs.
  * No longer need to provide a custom *-dbg package.
  * Do not build with -march=native. (Closes: #840166)
  * Fix build with GCC 6. (Closes: #811692)
  * Remove patches that are no longer required:
    - debian/patches/20140206-makefile_march.patch
    - debian/patches/gcc5.patch
    - debian/patches/20140208-no_sse.patch
    - debian/patches/20130803-kingTable.cc.patch
    - debian/patches/20130721-TIME_UTC.patch
    - debian/patches/0003-Customize-makefile.conf.patch
  * Add new/patches.

 -- Daigo Moriwaki <daigo@debian.org>  Mon, 05 Dec 2016 22:06:36 +0900

libosl (0.6.0-3.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with gcc-6, multiple issues. More remain.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 17 Aug 2016 14:05:11 +0100

libosl (0.6.0-3.3) unstable; urgency=medium

  * Non-maintainer upload.

  [ Steve Langasek ]
  * Rename library packages for g++5 ABI transition. (Closes: #797613)

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 19 Oct 2015 23:43:57 +0200

libosl (0.6.0-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with GCC 5 (Linn Crosetto). Closes: #777964.

 -- Matthias Klose <doko@debian.org>  Fri, 10 Jul 2015 13:24:57 +0200

libosl (0.6.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Changing B-D on boost to unversioned one. (Closes: #757540)

 -- Tobias Frost <tobi@debian.org>  Tue, 12 Aug 2014 17:06:15 +0000

=== debian/control ===
Source: libosl
Section: libs
Priority: optional
Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1~), debhelper-compat (= 12), doxygen, cmake, libcppunit-dev, libboost-all-dev, graphviz
Standards-Version: 4.5.0
Homepage: https://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/pukiwiki.php
Vcs-Git: https://salsa.debian.org/debian/libosl.git
Vcs-Browser: https://salsa.debian.org/debian/libosl

Package: libosl1v5
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libosl-doc
Conflicts: libosl1
Replaces: libosl1
Description: library for Shogi playing programs
 OpenShogiLib (OSL) provides following features of Shogi playing programs,
 especially for Shogi programming study. Shogi is a Japanese two-player board
 game like Chess.
 1. Board: reading/writing records, generating legal moves etc.
 2. Evaluation function: piece values and a lot of features
 3. Hash table: hashing boards etc.
 4. Checkmate search: concurrent df-pn+ etc.
 5. Search framework: full-depth search, realization probability etc.
 6. Move category: mate, illegal moves etc.
 7. Opening book
 8. Gaming: search time control etc.
 .
 OSL works only on Pentium4 or later compatible CPUs due to using the SSE2
 instruction set.

Package: libosl-dev
Section: libdevel
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, libosl1v5 (= ${binary:Version})
Description: library for Shogi playing programs
 OpenShogiLib (OSL) provides following features of Shogi playing programs,
 especially for Shogi programming study. Shogi is a Japanese two-player board
 game like Chess.
 1. Board: reading/writing records, generating legal moves etc.
 2. Evaluation function: piece values and a lot of features
 3. Hash table: hashing boards etc.
 4. Checkmate search: concurrent df-pn+ etc.
 5. Search framework: full-depth search, realization probability etc.
 6. Move category: mate, illegal moves etc.
 7. Opening book
 8. Gaming: search time control etc.
 .
 This package contains header files and static libraries for developers.

Package: libosl-doc
Section: doc
Architecture: all
Suggests: libosl1v5
Depends: libjs-jquery, ${misc:Depends}
Description: library for Shogi playing programs
 OpenShogiLib (OSL) provides following features of Shogi playing programs,
 especially for Shogi programming study. Shogi is a Japanese two-player board
 game like Chess.
 1. Board: reading/writing records, generating legal moves etc.
 2. Evaluation function: piece values and a lot of features
 3. Hash table: hashing boards etc.
 4. Checkmate search: concurrent df-pn+ etc.
 5. Search framework: full-depth search, realization probability etc.
 6. Move category: mate, illegal moves etc.
 7. Opening book
 8. Gaming: search time control etc.
 .
 This package contains documents that Doxygen generates from OSL source files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

#export DEB_BUILD_OPTIONS=noopt

CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

CMAKE_EXTRA_FLAGS += -DCMAKE_SKIP_RPATH=ON \
		     -DBUILD_SHARED_LIBS=1 \
		     -DCMAKE_BUILD_TYPE:STRING=Release
%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_build-indep:
	LANG=C $(MAKE) -C doc
	find doc -name \*.html | xargs sed -i -e 's!<script type="text/javascript" src="jquery.js">!<script type="text/javascript" src="/javascript/jquery/jquery.js">!g'
	-rm doc/doxygen.err
	-rm doc/html/jquery.js

override_dh_auto_clean:
	dh_auto_clean
	LANG=C make -C doc clean

get-orig-source:
	if [ ! -f osl.tar.gz ] ; then \
	  wget "http://gps.tanaka.ecc.u-tokyo.ac.jp/cgi-bin/viewvc.cgi/trunk/osl.tar.gz" ; \
	fi
	mkdir debian/$(SRCDIR_NAME)
	cd debian/$(SRCDIR_NAME) && tar xzvf ../../osl.tar.gz
	if test "`ls debian/$(SRCDIR_NAME) | wc -l`" -eq "1" ; then \
		subdir=`echo debian/$(SRCDIR_NAME)/*` && \
		mv $$subdir/* $$subdir/.??* debian/$(SRCDIR_NAME) && \
		rmdir $$subdir ; \
	fi
	rm -rf debian/$(SRCDIR_NAME)/public-domain
	tar czf ../$(SOURCE)_$(ORIG_VERSION).orig.tar.gz -C debian $(SRCDIR_NAME)
	rm -rf debian/$(SRCDIR_NAME)
